package Crawl;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import java.io.*;
import java.util.ArrayList;

public class CrawlLOS {
    public static void traverseAndMakeFoldersFromLosWeb(String rootUrl, int level, String folderpath) {
        ArrayList<String> temaerUrls = new ArrayList<String>();
        ArrayList<String> temaerNames = new ArrayList<String>();
        try {
            Document doc = Jsoup.connect(rootUrl).get();
            Element body = doc.body();
            Elements main = body.select("#main");
            Elements elements = null;
            if(level <= 3) {
                elements = main.get(0).select(".elements");
            }
            else {
                elements = main.get(0).select(".netresource");
            }

            for(Element e : elements) {
                Elements tema = e.select("a");
                temaerUrls.add(tema.get(0).attr("href"));
                temaerNames.add(tema.get(0).text());
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        if(level <= 3) {
            int count = 0;
            for(String url : temaerUrls) {
                File folder = new File(folderpath + temaerNames.get(count) + "/");
                if(!folder.exists()) {
                    folder.mkdir();
                }
                String spaces = "";
                if(level == 2)
                    spaces += "-> ";
                if(level == 3)
                    spaces += "--> ";
                System.out.println(spaces + "Folder: " + temaerNames.get(count));
                traverseAndMakeFoldersFromLosWeb("http://los.difi.no/" + url, level + 1, folderpath + temaerNames.get(count) + "/");
                count++;
            }
        }
        else {
            int count = 0;
            for(String url : temaerUrls) {
                try {
                    File file = new File(folderpath, temaerNames.get(count));
                    if(!file.exists()) {
                        System.out.println("File: " + temaerNames.get(count) + " url: " + url);
                        Document doc = Jsoup.connect(url).get();
                        BufferedWriter out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file),"UTF8"));
                                //new BufferedWriter(new FileWriter(folderpath + "/" + temaerNames.get(count)));
                        out.write(doc.html());
                        out.close();
                    }
                    count++;
                } catch (IOException e) {
                    System.out.println("Error on file: " + temaerNames.get(count) + " url: " + url);
                    e.printStackTrace();
                }
            }
        }
    }
    public static void main(String[] args) {
        traverseAndMakeFoldersFromLosWeb("http://los.difi.no/struktur/", 1, "/media/Master/LOS/");
    }
}
